; *_____________________________________________________________
; *
; *           Author: Terry Carmen 
; * Written 12/18/1992, in the early hours of the morning 
; * Released to the public domain
; *_____________________________________________________________
; *
; *
; *     Program Name:   translat.asm 
; *        $Revision$
; *            $Date$
; *
; *    Translates any ASCII string to anything else.
; *    Currently translates lower to upper, but can translate 
; *    ASCII -> EBCDIC, or foreign character sets
; *
; * Revision History:
; *             $Log$
; *
; *  Assemble with Turbo Assembler:   TASM /mx /w2 translat
; *
; *_____________________________________________________________


public  translate
        
extrn   __parinfo:far         ; how many params, etc
extrn   __parc:far            ; get a string parameter
extrn   __retc:far            ; return a string

dgroup  group   datasg
datasg  segment public  '_DATA'
assume cs:_prog, ds:dgroup, es:nothing

oldSI        dw  (?)

key_str      db 255 dup (0)   ; max string size of 255 chars

;The following table is a 256 byte array.
;
;Each byte contains the value of it's position. IE. the byte at 
;position 015h contains the value 015h. The exceptions are the hex
;values for the characters that are to be translated.
;
;For example, the byte at 041h, an ASCII 'A' contains an 041h, while
;the byte at 061h (ASCII 'a') also contains an 041h (ASCII 'A'). 
;Therefore, both an 'A' and an 'a' will return an 'A'
;
;While the primary purpose of this function is to do an UPPER() on
;any strings passed, it can also be used for any type of translation 
;like ASCII -> EBCIDIC, etc. All you have to do is modify trans_table
;


trans_table  db  000h, 001h, 002h, 003h, 004h, 005h, 006h, 007h
             db  008h, 009h, 00Ah, 00Bh, 00Ch, 00Dh, 00Eh, 00Fh
             db  010h, 011h, 012h, 013h, 014h, 015h, 016h, 017h
             db  018h, 019h, 01Ah, 01Bh, 01Ch, 01Dh, 01Eh, 01Fh
             db  020h, 021h, 022h, 023h, 024h, 025h, 026h, 027h
             db  028h, 029h, 02Ah, 02Bh, 02Ch, 02Dh, 02Eh, 02Fh
             db  030h, 031h, 032h, 033h, 034h, 035h, 036h, 037h
             db  038h, 039h, 03Ah, 03Bh, 03Ch, 03Dh, 03Eh, 03Fh
             db  040h, 041h, 042h, 043h, 044h, 045h, 046h, 047h
             db  048h, 049h, 04Ah, 04Bh, 04Ch, 04Dh, 04Eh, 04Fh
             db  050h, 051h, 052h, 053h, 054h, 055h, 056h, 057h
             db  058h, 059h, 05Ah, 05Bh, 05Ch, 05Dh, 05Eh, 05Fh
             db  060h, 041h, 042h, 043h, 044h, 045h, 046h, 047h 
             db  048h, 049h, 04Ah, 04Bh, 04Ch, 04Dh, 04Eh, 04Fh 
             db  050h, 051h, 052h, 053h, 054h, 055h, 056h, 057h 
             db  058h, 059h, 05Ah, 07Bh, 07Ch, 07Dh, 07Eh, 07Fh
             db  080h, 081h, 082h, 083h, 084h, 085h, 086h, 087h
             db  088h, 089h, 08Ah, 08Bh, 08Ch, 08Dh, 08Eh, 08Fh
             db  090h, 091h, 092h, 093h, 094h, 095h, 096h, 097h
             db  098h, 099h, 09Ah, 09Bh, 09Ch, 09Dh, 09Eh, 09Fh
             db  0A0h, 0A1h, 0A2h, 0A3h, 0A4h, 0A5h, 0A6h, 0A7h
             db  0A8h, 0A9h, 0AAh, 0ABh, 0ACh, 0ADh, 0AEh, 0AFh
             db  0B0h, 0B1h, 0B2h, 0B3h, 0B4h, 0B5h, 0B6h, 0B7h
             db  0B8h, 0B9h, 0BAh, 0BBh, 0BCh, 0BDh, 0BEh, 0BFh
             db  0C0h, 0C1h, 0C2h, 0C3h, 0C4h, 0C5h, 0C6h, 0C7h
             db  0C8h, 0C9h, 0CAh, 0CBh, 0CCh, 0CDh, 0CEh, 0CFh
             db  0D0h, 0D1h, 0D2h, 0D3h, 0D4h, 0D5h, 0D6h, 0D7h
             db  0D8h, 0D9h, 0DAh, 0DBh, 0DCh, 0DDh, 0DEh, 0DFh
             db  0E0h, 0E1h, 0E2h, 0E3h, 0E4h, 0E5h, 0E6h, 0E7h
             db  0E8h, 0E9h, 0EAh, 0EBh, 0ECh, 0EDh, 0EEh, 0EFh
             db  0F0h, 0F1h, 0F2h, 0F3h, 0F4h, 0F5h, 0F6h, 0F7h
             db  0F8h, 0F9h, 0FAh, 0FBh, 0FCh, 0FDh, 0FEh, 0FFh
            

datasg  ends

_prog   segment 'CODE'


translate       proc    far

                push    bp         
                mov     bp,sp     
                push    si
                push    di

                mov     di, offset key_str   
                mov     ax, 1                  ; get first param 
                push    ax
                call    __parinfo
                add     sp,2

                cmp     ax, 1      ; is it a character string?
                jne     @@bye      ; not 1 param? bye!

                push    ax         ; it already contains a 1
                call    __parc     ; DX:AX now contain the 
                add     sp, 2      ; starting address of the string

                mov     es, dx     ; ES:SI point to our Clipper string
                mov     si, ax

                mov     ax, seg trans_table    ; point ds:bx to our table
                mov     ds, ax
                mov     bx, offset trans_table ; setup for XLAT

@@next_char:    mov     al, byte ptr es:[si]   ; get character from Clipper
                cmp     al, 0                  ; end of string?
                je      @@bye
                xlat                           ; AL <- DS:BX+AL
                mov     [di], al               ; save in our string area 
                inc     si                     ; point to next source char
                inc     di                     ; point to next dest char
                jmp     short  @@next_char     ; run this loop until CX=0

@@bye:          mov    byte ptr [di], 0   ; leave the null at the end
                mov   dx, seg key_str
                mov   ax, offset key_str  ; return the string to Clipper
                push  dx                  ; push string address for __retc
                push  ax
                mov     ax, seg dgroup    ; tell Clipper how to find itself
                mov     ds, ax            ; it gets confused easily 8-)
                call  __retc
                add   sp, 4               

                pop     di
                pop     si
                pop     bp
                ret                              ; far return to Clipper
                
translate       endp
_prog           ends
                end


